SystemOrganization addCategory: #'TinyWiki-Component'!
SystemOrganization addCategory: #'TinyWiki-Core'!
SystemOrganization addCategory: #'TinyWiki-Document'!
SystemOrganization addCategory: #'TinyWiki-Visitor'!

Object subclass: #TWDocumentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

TWDocumentNode subclass: #TWComposed
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWComposed class methodsFor: 'instance creation' stamp: 'pmm 10/8/2007 20:38'!
with: anObject
	^self withAll: (Array with: anObject)! !

!TWComposed class methodsFor: 'instance creation' stamp: 'lr 3/28/2004 19:51'!
withAll: aCollection
	^self new
		children: aCollection asOrderedCollection;
		yourself! !

!TWComposed methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:35'!
accept: aVisitor
	aVisitor visitComposed: self! !

!TWComposed methodsFor: 'accessing' stamp: 'lr 3/28/2004 19:49'!
add: anObject
	self addLast: anObject.! !

!TWComposed methodsFor: 'accessing' stamp: 'lr 3/28/2004 19:49'!
addFirst: anObject
	self children addFirst: anObject.! !

!TWComposed methodsFor: 'accessing' stamp: 'lr 3/28/2004 19:49'!
addLast: anObject
	self children addLast: anObject.! !

!TWComposed methodsFor: 'accessing' stamp: 'lr 3/27/2004 08:58'!
children
	^children.! !

!TWComposed methodsFor: 'accessing' stamp: 'lr 3/27/2004 08:58'!
children: aCollection
	children := aCollection.! !

!TWComposed methodsFor: 'initialize-release' stamp: 'lr 12/4/2008 16:48'!
initialize
	super initialize.
	children := OrderedCollection new.! !

TWComposed subclass: #TWDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWDocument methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:38'!
accept: aVisitor
	aVisitor visitDocument: self! !

TWComposed subclass: #TWHeading
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWHeading class methodsFor: 'instance creation' stamp: 'pmm 10/8/2007 20:40'!
with: anObject level: anInteger
	^self withAll: (Array with: anObject) level: anInteger! !

!TWHeading class methodsFor: 'instance creation' stamp: 'lr 3/27/2004 00:52'!
withAll: aCollection level: anInteger
	^(self withAll: aCollection)
		level: anInteger;
		yourself! !

!TWHeading methodsFor: 'visiting' stamp: 'lr 3/26/2004 22:40'!
accept: aVisitor
	aVisitor visitHeading: self! !

!TWHeading methodsFor: 'accessing' stamp: 'lr 3/26/2004 22:41'!
level
	^level! !

!TWHeading methodsFor: 'accessing' stamp: 'lr 3/26/2004 22:41'!
level: anInteger
	level := anInteger! !

TWComposed subclass: #TWList
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWList class methodsFor: 'defaults' stamp: 'lr 3/26/2004 23:00'!
ordered
	^self type: $#! !

!TWList class methodsFor: 'instance creation' stamp: 'lr 3/27/2004 00:54'!
type: aCharacter
	^self new
		type: aCharacter
		yourself! !

!TWList class methodsFor: 'instance creation' stamp: 'lr 3/27/2004 09:24'!
withAll: aCollection type: aCharacter
	^self new
		children: aCollection;
		type: aCharacter;
		yourself! !

!TWList methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:38'!
accept: aVisitor
	aVisitor visitList: self! !

!TWList methodsFor: 'testing' stamp: 'lr 3/26/2004 23:21'!
isOrdered
	^self type = $#! !

!TWList methodsFor: 'testing' stamp: 'lr 3/26/2004 23:21'!
isPreformatted
	^self type = $=! !

!TWList methodsFor: 'testing' stamp: 'lr 3/26/2004 23:21'!
isUnordered
	^self type = $-! !

!TWList methodsFor: 'accessing' stamp: 'lr 3/26/2004 22:57'!
type
	^type! !

!TWList methodsFor: 'accessing' stamp: 'lr 3/26/2004 22:57'!
type: aCharacter
	type := aCharacter! !

TWComposed subclass: #TWListItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWListItem methodsFor: 'visiting' stamp: 'lr 3/26/2004 23:19'!
accept: aVisitor
	aVisitor visitListItem: self! !

TWComposed subclass: #TWParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWParagraph methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:38'!
accept: aVisitor
	aVisitor visitParagraph: self! !

TWComposed subclass: #TWReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWReference methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:39'!
accept: aVisitor
	aVisitor visitReference: self! !

!TWReference methodsFor: 'testing' stamp: 'lr 12/4/2008 16:47'!
isUrl
	^ (self text beginsWith: 'http://') or: [ (self text beginsWith: 'https://') or: [ (self text beginsWith: 'ftp://') or: [ self text beginsWith: 'mailto:' ] ] ]! !

!TWReference methodsFor: 'accessing' stamp: 'lr 3/26/2004 23:47'!
text
	^String streamContents: [ :stream |
		self children do: [ :each |
			(each isKindOf: TWText)
				ifTrue: [ stream nextPutAll: each text ] ] ]! !

!TWDocumentNode methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:30'!
accept: aVisitor! !

TWDocumentNode subclass: #TWRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWRule methodsFor: 'visiting' stamp: 'lr 3/26/2004 22:43'!
accept: aVisitor
	aVisitor visitRule: self! !

TWDocumentNode subclass: #TWText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWText class methodsFor: 'instance creation' stamp: 'lr 3/26/2004 22:36'!
text: aString
	^self new
		text: aString;
		yourself! !

!TWText methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:31'!
accept: aVisitor
	aVisitor visitText: self! !

!TWText methodsFor: 'accessing' stamp: 'lr 3/26/2004 09:32'!
text
	^text! !

!TWText methodsFor: 'accessing' stamp: 'lr 3/26/2004 09:32'!
text: aString
	text := aString! !

Object subclass: #TWStructure
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Core'!

TWStructure subclass: #TWFolder
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Core'!

!TWFolder methodsFor: 'visiting' stamp: 'lr 3/27/2004 10:03'!
accept: aVisitor
	aVisitor visitFolder: self! !

!TWFolder methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:57'!
add: aStructure
	^children 
		at: aStructure title 
		put: (aStructure parent: self).! !

!TWFolder methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:41'!
at: aString
	^children at: aString! !

!TWFolder methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:41'!
at: aString ifAbsent: aBlock
	^children at: aString ifAbsent: aBlock! !

!TWFolder methodsFor: 'accessing' stamp: 'lr 3/28/2004 09:44'!
children
	^children values! !

!TWFolder methodsFor: 'initialize-release' stamp: 'pmm 10/8/2007 20:41'!
defaultHead
	^TWHeading 
		with: (TWText text: 'Welcome to TinyWiki')
		level: 1! !

!TWFolder methodsFor: 'accessing' stamp: 'lr 3/28/2004 20:06'!
home
	^self
		at: self title
		ifAbsent: [ self initializeHome ]! !

!TWFolder methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:41'!
includes: aString
	^children includesKey: aString! !

!TWFolder methodsFor: 'initialize-release' stamp: 'lr 12/4/2008 16:44'!
initialize
	super initialize.
	self initializeChildren.
	self initializeHome! !

!TWFolder methodsFor: 'initialize-release' stamp: 'lr 3/27/2004 09:16'!
initializeChildren
	children := Dictionary new.! !

!TWFolder methodsFor: 'initialize-release' stamp: 'lr 12/4/2008 16:44'!
initializeHelp
	self add: (TWPage new
		title: 'Help';
		document: (TWDocument withAll: (OrderedCollection new
			add: self defaultHead;
			add: self tinyWikiIntroduction;
			add: self markupSupportedParagraph;
			add: self tinyWikiSyntax;
			add: self tinyWikiOutro;
			yourself));
		yourself)! !

!TWFolder methodsFor: 'initialize-release' stamp: 'lr 12/4/2008 16:44'!
initializeHome
	| page |
	page := TWPage title: self title.
	page document addFirst: (TWHeading with: (TWText text: self title) level: 1).
	self add: page! !

!TWFolder methodsFor: 'initialize-release' stamp: 'pmm 10/8/2007 20:39'!
markupSupportedParagraph
	^TWParagraph with: (TWText text: 'The following markup is currently supported:')! !

!TWFolder methodsFor: 'initialize-release' stamp: 'lr 12/4/2008 14:31'!
tinyWikiIntroduction
	^TWParagraph withAll: (Array
		with: (TWText text: 'TinyWiki is implementing the most basic features of Pier only. However it is fully object-oriented, easily extensible and useable in different contexts.'))! !

!TWFolder methodsFor: 'initialize-release' stamp: 'lr 12/4/2008 14:31'!
tinyWikiOutro
	^TWParagraph with: (TWText text: 'If you are looking for more advanced features, check-out Pier available in several Smalltalk dialects. Enjoy.')! !

!TWFolder methodsFor: 'initialize-release' stamp: 'lr 12/4/2008 14:30'!
tinyWikiSyntax
	^TWList withAll: (OrderedCollection new
			add: (TWListItem with: (TWText text: '<strong>Paragraph:</strong> Carriage returns are used to form paragraphs.'));
			add: (TWListItem with: (TWText text: '<strong>Header:</strong> Lines starting with <code>!!</code> becomes a header.'));
			add: (TWListItem with: (TWText text: '<strong>Hoizontal Rule:</strong> A line with <code>_</code> becomes a horizontal rule.'));
			add: (TWListItem with: (TWText text: '<strong>Lists:</strong> A block of lines starting with <code>#</code> or <code>-</code> becomes an ordered-/unordered list.'));
			add: (TWListItem with: (TWText text: '<strong>Preformatted:</strong> A block of lines starting with <code>=</code> becomes a preformatted text.'));
			add: (TWListItem with: (TWText text: '<strong>Links:</strong> Text between <code>*</code> becomes a link. If the text withing the stars starts out with a common know protocol, an external-link will be created else an internal one.'));
			add: (TWListItem with: (TWText text: '<strong>XHTML:</strong> Use any valid XHTML you want.'));
			yourself)
		type: $-.! !

!TWFolder methodsFor: 'accessing' stamp: 'lr 3/28/2004 20:07'!
title
	^'Home'! !

TWStructure subclass: #TWPage
	instanceVariableNames: 'title document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Core'!

!TWPage class methodsFor: 'instance creation' stamp: 'lr 3/27/2004 13:02'!
title: aString
	^self new
		title: aString;
		yourself! !

!TWPage methodsFor: 'visiting' stamp: 'lr 3/27/2004 10:03'!
accept: aVisitor
	aVisitor visitPage: self! !

!TWPage methodsFor: 'accessing' stamp: 'lr 3/25/2004 17:27'!
document
	^document! !

!TWPage methodsFor: 'accessing' stamp: 'lr 3/25/2004 17:27'!
document: aDocument
	document := aDocument! !

!TWPage methodsFor: 'initialize-release' stamp: 'lr 3/27/2004 09:12'!
initialize
	super initialize.
	self initializeDocument.! !

!TWPage methodsFor: 'initialize-release' stamp: 'pmm 10/8/2007 20:51'!
initializeDocument
	document := TWDocument with: (
		TWParagraph with: (
			TWText text: 'Edit your page'))! !

!TWPage methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:45'!
title
	^title! !

!TWPage methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:45'!
title: aString
	title := aString! !

!TWStructure class methodsFor: 'instance creation' stamp: 'lr 3/27/2004 09:44'!
parent: aStructure
	^self new
		parent: aStructure;
		yourself! !

!TWStructure methodsFor: 'visiting' stamp: 'lr 3/27/2004 10:03'!
accept: aVisitor
	aVisitor visitStructure: self! !

!TWStructure methodsFor: 'configuration' stamp: 'lr 3/28/2004 09:29'!
editor
	^TWEditor! !

!TWStructure methodsFor: 'testing' stamp: 'lr 3/27/2004 09:07'!
isRoot
	^self parent isNil! !

!TWStructure methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:07'!
parent
	^parent! !

!TWStructure methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:11'!
parent: aStructure
	parent := aStructure
! !

!TWStructure methodsFor: 'configuration' stamp: 'chc 8/29/2016 11:15'!
parser
	| parser wikiGrammar |
	wikiGrammar := wikiGrammar := PEGParser grammarWiki.
	parser := PEGParser parserPEG parse: 'Grammar' stream: wikiGrammar actor: PEGParserParser new.
	^parser! !

!TWStructure methodsFor: 'accessing' stamp: 'lr 12/4/2008 16:42'!
title
	self subclassResponsibility! !

!TWStructure methodsFor: 'configuration' stamp: 'lr 3/28/2004 19:02'!
viewer
	^TWViewer! !

Object subclass: #TWVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Visitor'!

TWVisitor subclass: #TWReferences
	instanceVariableNames: 'references target structure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Visitor'!

!TWReferences class methodsFor: 'instance creation' stamp: 'lr 12/4/2008 16:44'!
to: aStructure startAt: anotherStructure
	^ self new
		setTarget: aStructure;
		visit: anotherStructure;
		references! !

!TWReferences methodsFor: 'initialize-release' stamp: 'lr 3/28/2004 18:30'!
initialize
	super initialize.
	references := Set new.! !

!TWReferences methodsFor: 'accessing' stamp: 'lr 3/28/2004 18:30'!
references
	^references! !

!TWReferences methodsFor: 'initialize-release' stamp: 'lr 3/28/2004 18:30'!
setTarget: anObject
	target := anObject! !

!TWReferences methodsFor: 'visiting' stamp: 'lr 3/28/2004 18:31'!
visitReference: anObject
	target title = anObject text
		ifTrue: [ references add: structure ]! !

!TWReferences methodsFor: 'visiting' stamp: 'lr 3/28/2004 18:28'!
visitStructure: anObject
	structure := anObject! !

TWVisitor subclass: #TWRenderer
	instanceVariableNames: 'model controller renderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Visitor'!

TWRenderer subclass: #TWEditor
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Visitor'!

!TWEditor methodsFor: 'actions' stamp: 'lr 3/28/2004 19:27'!
cancel
	self controller view: self model.! !

!TWEditor methodsFor: 'actions' stamp: 'lr 3/30/2004 19:20'!
parse
	| input |
	[ self model document: (self model parser parse: self text) ]
		on: SmaCCParserError
		do: [ :error |
			input := self text readStream.
			self text: (String streamContents: [ :output |
				output nextPutAll: (input next: error tag position - 1).
				output nextPutAll: error messageText.
				output nextPutAll: '-->'.
				output nextPutAll: input upToEnd ]).
			^self ].
	self controller onSaved.
	self cancel.! !

!TWEditor methodsFor: 'actions' stamp: 'lr 3/28/2004 19:30'!
save	
	[ self parse ]
		on: SmaCCParserError 
		do: [ :error | nil ].! !

!TWEditor methodsFor: 'accessing' stamp: 'lr 3/27/2004 10:26'!
text
	text isNil ifTrue: [
		text := String streamContents: [ :stream |
			self renderOn: stream during: [ 
				self visit: self model document ] ] ].
	^text! !

!TWEditor methodsFor: 'accessing' stamp: 'al 3/29/2004 22:35'!
text: aString
	text := aString! !

!TWEditor methodsFor: 'visiting' stamp: 'lr 3/27/2004 12:57'!
visitHeading: anObject
	anObject level timesRepeat: [ renderer nextPut: $!! ].
	super visitHeading: anObject.
	renderer cr.! !

!TWEditor methodsFor: 'visiting' stamp: 'lr 3/27/2004 10:29'!
visitList: anObject
	anObject children do: [ :each | 
		renderer nextPut: anObject type.
		self visit: each.
		renderer cr ]! !

!TWEditor methodsFor: 'visiting' stamp: 'chc 8/29/2016 11:16'!
visitPage: anObject
	renderer form: [
		renderer textarea 
			"callback: [:str | Compiler evaluate: str unescapePercents];"
			callback: [:str| self model document: (self model parser parse: 'Page' stream: str actor: PWActor new) ];
			style: 'width: 100%; height: 300px';
		"	on: #text of: self."
			with: self text.
	
		renderer br. 
		renderer br.
		
		renderer input beTypeSubmit.
		"renderer submitButton			
			callback: [ self save ];
			text: 'Save'.
			
		renderer space.
		
		renderer submitButton
			callback: [ self cancel ];
			text: 'Cancel'" ].! !

!TWEditor methodsFor: 'visiting' stamp: 'lr 3/26/2004 23:00'!
visitParagraph: anObject
	super visitParagraph: anObject.
	renderer cr.! !

!TWEditor methodsFor: 'visiting' stamp: 'lr 3/26/2004 23:03'!
visitReference: anObject
	renderer nextPut: $*.
	super visitReference: anObject.
	renderer nextPut: $*.! !

!TWEditor methodsFor: 'visiting' stamp: 'lr 3/26/2004 22:54'!
visitRule: aRule
	renderer nextPut: $_; cr.! !

!TWEditor methodsFor: 'visiting' stamp: 'lr 3/26/2004 23:05'!
visitText: anObject
	renderer nextPutAll: anObject text.! !

!TWRenderer class methodsFor: 'instance creation' stamp: 'lr 3/28/2004 18:35'!
on: aModel controller: aController
	^self new
		setModel: aModel controller: aController;
		yourself! !

!TWRenderer methodsFor: 'accessing' stamp: 'lr 3/28/2004 18:55'!
controller
	^controller! !

!TWRenderer methodsFor: 'accessing' stamp: 'lr 3/28/2004 18:25'!
model
	^model! !

!TWRenderer methodsFor: 'rendering' stamp: 'lr 3/28/2004 18:51'!
renderOn: aRenderer
	self renderOn: aRenderer during: [ self visit: self model ].! !

!TWRenderer methodsFor: 'rendering' stamp: 'pmm 8/26/2007 10:36'!
renderOn: aRenderer during: aBlock
	| temp |
	temp := renderer.
	renderer := aRenderer.
	aBlock value.
	renderer := temp.! !

!TWRenderer methodsFor: 'initialize-release' stamp: 'pmm 8/26/2007 10:36'!
setModel: aModel controller: aController
	model := aModel.
	controller := aController.! !

TWRenderer subclass: #TWViewer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Visitor'!

!TWViewer methodsFor: 'visiting' stamp: 'lr 12/4/2008 14:17'!
visitFolder: anObject
	renderer unorderedList: [
		anObject children
			do: [ :each | self controller renderWikiReference: each on: renderer ] ]! !

!TWViewer methodsFor: 'visiting' stamp: 'chc 7/22/2016 10:24'!
visitHeading: anObject
	renderer h1: [ super visitHeading: anObject ]! !

!TWViewer methodsFor: 'visiting' stamp: 'lr 3/27/2004 13:00'!
visitList: anObject
	anObject isOrdered
		ifTrue: [ renderer orderedList: [ super visitList: anObject ] ]
		ifFalse: [
			anObject isUnordered
				ifTrue: [ renderer unorderedList: [ super visitList: anObject ] ]
				ifFalse: [
					anObject isPreformatted 
						ifTrue: [ self visitPreformatted: anObject ] ] ].! !

!TWViewer methodsFor: 'visiting' stamp: 'lr 3/26/2004 23:20'!
visitListItem: anObject
	renderer listItem: [ super visitListItem: anObject ].! !

!TWViewer methodsFor: 'visiting' stamp: 'lr 3/28/2004 09:39'!
visitPage: anObject
	self visit: anObject document.
	self visitStructure: anObject.! !

!TWViewer methodsFor: 'visiting' stamp: 'chc 7/22/2016 10:25'!
visitParagraph: anObject
	anObject children isEmpty ifFalse: [
		renderer p: [ super visitParagraph: anObject ] ].! !

!TWViewer methodsFor: 'visiting' stamp: 'pmm 8/26/2007 10:42'!
visitPreformatted: anObject
	renderer preformatted: [
		anObject children
			do: [ :each | self visitAll: each children ]
			separatedBy: [ renderer text: String cr ] ]! !

!TWViewer methodsFor: 'visiting' stamp: 'pmm 8/26/2007 10:37'!
visitReference: anObject
	anObject isUrl
		ifFalse: [ self controller renderWikiReferenceString: anObject text on: renderer ]
		ifTrue: [
			renderer anchor
				url: anObject text;
				with: [ super visitReference: anObject ] ]! !

!TWViewer methodsFor: 'visiting' stamp: 'pmm 8/26/2007 10:41'!
visitRule: anObject
	renderer horizontalRule! !

!TWViewer methodsFor: 'visiting' stamp: 'pmm 10/9/2007 07:06'!
visitText: anObject
	renderer html: anObject text! !

!TWVisitor methodsFor: 'private' stamp: 'lr 3/27/2004 10:00'!
visit: anObject
	anObject accept: self! !

!TWVisitor methodsFor: 'private' stamp: 'lr 3/27/2004 10:04'!
visitAll: aCollection
	aCollection do: [ :each | 
		each accept: self ]! !

!TWVisitor methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:36'!
visitComposed: anObject
	self visitAll: anObject children! !

!TWVisitor methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:36'!
visitDocument: anObject
	self visitComposed: anObject! !

!TWVisitor methodsFor: 'visiting' stamp: 'lr 3/28/2004 09:43'!
visitFolder: anObject
	self visitStructure: anObject.
	self visitAll: anObject children.! !

!TWVisitor methodsFor: 'visiting' stamp: 'lr 3/26/2004 22:41'!
visitHeading: anObject
	self visitComposed: anObject! !

!TWVisitor methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:36'!
visitList: anObject
	self visitComposed: anObject! !

!TWVisitor methodsFor: 'visiting' stamp: 'lr 3/26/2004 23:19'!
visitListItem: anObject
	self visitComposed: anObject! !

!TWVisitor methodsFor: 'visiting' stamp: 'lr 3/28/2004 09:43'!
visitPage: anObject
	self visitStructure: anObject.
	self visit: anObject document.
	! !

!TWVisitor methodsFor: 'visiting' stamp: 'lr 3/27/2004 12:57'!
visitParagraph: anObject
	self visitComposed: anObject! !

!TWVisitor methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:37'!
visitReference: anObject
	self visitComposed: anObject! !

!TWVisitor methodsFor: 'visiting' stamp: 'lr 3/26/2004 22:43'!
visitRule: anObject! !

!TWVisitor methodsFor: 'visiting' stamp: 'lr 3/28/2004 09:43'!
visitStructure: anObject! !

!TWVisitor methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:34'!
visitText: anObject! !

ALExample subclass: #TWWiki
	instanceVariableNames: 'model visitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Component'!

!TWWiki class methodsFor: 'examples' stamp: 'lr 12/4/2008 14:31'!
example
	^ self on: TWFolder new initializeHelp! !

!TWWiki class methodsFor: 'instance creation' stamp: 'lr 3/28/2004 09:25'!
on: anObject	
	^self new
		setModel: anObject;
		yourself! !

!TWWiki methodsFor: 'accessing' stamp: 'lr 12/4/2008 14:22'!
actions
	^#( ( 'View' #view: $v ) ( 'Edit' #edit:	 $e ) ( 'Home' #home $h ))! !

!TWWiki methodsFor: 'actions' stamp: 'lr 12/4/2008 16:45'!
create: aString
	| page |
	page := TWPage title: aString.
	page document addFirst: (TWHeading 
		withAll: (Array with: (TWText text: aString))
		level: 1).
	self view: (self model add: page)! !

!TWWiki methodsFor: 'actions' stamp: 'lr 3/28/2004 18:53'!
edit: aStructure
	self visitor: aStructure editor on: aStructure.! !

!TWWiki methodsFor: 'actions' stamp: 'pmm 8/26/2007 10:43'!
home
	self visitor: self model home viewer on: self model home! !

!TWWiki methodsFor: 'accessing' stamp: 'lr 12/4/2008 14:19'!
model
	^ model! !

!TWWiki methodsFor: 'events' stamp: 'lr 3/30/2004 19:19'!
onSaved! !

!TWWiki methodsFor: 'rendering' stamp: 'pmm 8/26/2007 10:44'!
renderContentOn: html
	html div
		class: 'wiki';
		with: [
			html div
				class: 'wikiheader';
				with: [ self renderWikiHeaderOn: html ].
			html div
				class: 'wikicontent';
				with: [ self renderWikiContentOn: html ].
			html div
				class: 'wikifooter';
				with: [ self renderWikiFooterOn: html ] ]! !

!TWWiki methodsFor: 'rendering-wiki' stamp: 'lr 12/4/2008 14:23'!
renderWikiAction: aSelector titled: aString key: aCharacter  argument: aStructure on: html
	html anchor
		accessKey: aCharacter;
		callback: [ 
			self
				perform: aSelector 
				withArguments: (aSelector numArgs isZero
					ifTrue: [ Array new ] 
					ifFalse: [ Array with: aStructure ]) ];
		with: aString! !

!TWWiki methodsFor: 'rendering-wiki' stamp: 'lr 12/4/2008 14:22'!
renderWikiActionsOn: html
	html heading level1; with: 'Actions'.
	html div
		class: 'list';
		with: [
			self actions do: [ :array |
				html div
					class: 'listItem';
					with: [
						self 
							renderWikiAction: array  second
							titled: array first
							key: array third
							argument: self visitor model 
							on: html ] ] ]! !

!TWWiki methodsFor: 'rendering' stamp: 'pmm 8/26/2007 10:44'!
renderWikiContentOn: html
	html render: visitor! !

!TWWiki methodsFor: 'rendering' stamp: 'pmm 8/26/2007 10:44'!
renderWikiFooterOn: html
	self renderWikiReferencesOn: html! !

!TWWiki methodsFor: 'rendering' stamp: 'pmm 8/26/2007 10:44'!
renderWikiHeaderOn: html
	self renderWikiActionsOn: html! !

!TWWiki methodsFor: 'rendering-references' stamp: 'lr 12/4/2008 14:17'!
renderWikiReference: aStructure on: html
	html anchor
		callback: [ self view: aStructure ];
		with: aStructure title! !

!TWWiki methodsFor: 'rendering-references' stamp: 'pmm 8/26/2007 10:47'!
renderWikiReferenceString: aString on: html
	| structure |
	structure := self model at: aString ifAbsent: [ nil ].
	structure isNil
		ifFalse: [ self renderWikiReference: structure on: html ]
		ifTrue: [
			html anchor
				callback: [ self create: aString ];
				with: aString.
			html strong: '?' ]! !

!TWWiki methodsFor: 'rendering-wiki' stamp: 'lr 12/4/2008 16:43'!
renderWikiReferencesOn: html
	| references |
	references := TWReferences to: self visitor model startAt: self model.
	references isEmpty ifTrue: [ ^ self ].
	html heading level1; with: 'References'.
	html div
		class: 'list';
		with: [
			references do: [ :each |
				html div
					class: 'listItem';
					with: [ self renderWikiAction: #view: titled: each title key: nil argument: each on: html ] ] ]
! !

!TWWiki methodsFor: 'initialization' stamp: 'pmm 8/26/2007 10:47'!
setModel: anObject
	self view: (model := anObject) home! !

!TWWiki methodsFor: 'actions' stamp: 'pmm 8/26/2007 10:43'!
view: aStructure
	self visitor: aStructure viewer on: aStructure! !

!TWWiki methodsFor: 'accessing' stamp: 'lr 12/4/2008 14:19'!
visitor
	^ visitor! !

!TWWiki methodsFor: 'private' stamp: 'pmm 8/26/2007 10:48'!
visitor: aClass on: aStructure
	visitor := aClass on: aStructure controller: self.! !
